module.exports = {
	parser: 'babel-eslint',
	extends: 'airbnb',
	plugins: [
		'react',
		'flowtype',
	],
	rules: {
		'func-names': ['error', 'never'],
		'no-tabs': 'off',
		'global-require': 'off',
		'no-shadow': 'off',
		'key-spacing': 'off',
		'no-param-reassign': 'off',
		'no-restricted-syntax': ['error', 'ForInStatement', 'LabeledStatement', 'WithStatement'],
		'one-var': 'off',
		'eol-last': 'off',
		'comma-dangle': 'off',
		'indent': [2, 'tab'],
		'array-bracket-spacing': 'off',
		'object-property-newline': 'off',
		'object-curly-newline': 'off',
		'no-unused-expressions': 'warn',
		'no-unused-vars': 'warn',
		'no-else-return': 'off',
		'no-use-before-define': 'off',
		'arrow-body-style': 'off',
		'one-var-declaration-per-line': 'off',
		'import/no-extraneous-dependencies': 'off',
		'import/no-named-as-default': 'off',
		'import/prefer-default-export': 'off',
		'react/require-default-props': 'off',
		'react/forbid-prop-types': 'off',
		'react/sort-comp': 'off',
		'react/no-unused-prop-types': 'off',
		'react/no-array-index-key': 'off',
		'react/prefer-stateless-function': 'off',
		'react/jsx-filename-extension': 'off',
		'react/jsx-indent-props': 'off',
		'react/jsx-wrap-multilines': 'off',
		'react/jsx-indent': 'off',
		'react/jsx-closing-bracket-location': 'off',
		'react/jsx-closing-tag-location': 'off',
		'react/jsx-space-before-closing': 'off',
		'react/jsx-tag-spacing': 'off',
	},
	globals: {
		localStorage: true,
		window: true,
		Headers: true,
		fetch: true,
		document: true
	}
};
