"use strict";

var childProcess, execSync, fs, installDependencies, path;
fs = require("fs");
path = require("path");
childProcess = require("child_process");
({
  execSync
} = childProcess);

installDependencies = function (depencencies, yarnVersion, isDev) {
  var depToInstall, dependencyType, name, results, saveType, version;

  if (Object.keys(depencencies).length === 0) {
    return;
  }

  dependencyType = isDev ? "develop dependencies" : "dependencies";
  console.log("Setting up ".concat(dependencyType, "."));
  results = [];

  for (name in depencencies) {
    version = depencencies[name];
    depToInstall = version ? "".concat(name, "@").concat(version, " ") : name;
    console.log("Adding ".concat(depToInstall, "..."));

    if (yarnVersion) {
      saveType = isDev ? " -D" : "";
      results.push(execSync("yarn add ".concat(depToInstall).concat(saveType, " --save-exact"), {
        stdio: "inherit"
      }));
    } else {
      saveType = isDev ? " --save-dev" : " --save";
      results.push(execSync("npm install ".concat(depToInstall).concat(saveType, " --save-exact"), {
        stdio: "inherit"
      }));
    }
  }

  return results;
};

module.exports = {
  installDependencies
};
//# sourceMappingURL=templates.js.map