"use strict";

var execSync, fs, getYarnVersionIfAvailable, isProjectUsingYarn, logger, path, semver;
({
  execSync
} = require("child_process"));
fs = require("fs");
path = require("path");
semver = require("semver");
logger = require("./logger");

getYarnVersionIfAvailable = function () {
  var error, yarnVersion;
  yarnVersion = null;

  try {
    yarnVersion = execSync("yarn --version", {
      stdio: [0, 'pipe', 'ignore']
    }).toString() || "";
    yarnVersion = yarnVersion.trim();
  } catch (error1) {
    error = error1;
    return null;
  }

  try {
    if (semver.gte(yarnVersion, "0.16.0")) {
      return yarnVersion;
    }
  } catch (error1) {
    error = error1;
    logger.error("Cannot parse yarn version: ".concat(yarnVersion));
    return null;
  }
};

isProjectUsingYarn = function (projectDir) {
  return fs.existsSync(path.join(projectDir, 'yarn.lock'));
};

module.exports = {
  getYarnVersionIfAvailable,
  isProjectUsingYarn
};
//# sourceMappingURL=yarn.js.map