"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _reactNativeReanimated = _interopRequireDefault(require("react-native-reanimated"));

var _utils = require("../../utils");

var appActions = _interopRequireWildcard(require("../../utils/store/appAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const {
  Clock,
  Value,
  useCode,
  call,
  cond,
  eq,
  greaterOrEq,
  set,
  interpolate,
  stopClock
} = _reactNativeReanimated.default;
const translateDistance = 50;

const Modal = props => {
  const {
    dispatch,
    item
  } = props;
  const {
    current: leaveState
  } = (0, _react.useRef)(new Value(0));
  const {
    current: enterClock
  } = (0, _react.useRef)(new Clock());
  const {
    current: leaveClock
  } = (0, _react.useRef)(new Clock());
  const {
    current: enterTranslate
  } = (0, _react.useRef)(new Value(translateDistance));
  const {
    current: leaveTranslate
  } = (0, _react.useRef)(new Value(0));
  const InnerComponent = item.configs.component;

  const onClose = () => {
    dispatch(appActions.toggleModal(false, item.configs));
  };

  const enterAnimator = [set(enterTranslate, (0, _utils.spring)({
    clock: enterClock,
    from: translateDistance,
    to: 0
  }))];
  const leaveAnimator = [set(leaveTranslate, (0, _utils.spring)({
    clock: leaveClock,
    from: 0,
    to: translateDistance
  })), cond(greaterOrEq(leaveTranslate, translateDistance), [stopClock(leaveClock), call([], onClose)])];
  useCode(() => cond(eq(leaveState, 1), leaveAnimator, enterAnimator), []);

  const onRequestClose = () => leaveState.setValue(1);

  const translate = cond(eq(leaveState, 1), leaveTranslate, enterTranslate);
  const scale = interpolate(translate, {
    inputRange: [0, translateDistance],
    outputRange: [1, 0.5]
  });
  const maskOpacity = interpolate(translate, {
    inputRange: [0, translateDistance / 2, translateDistance],
    outputRange: [0.8, 0, 0]
  });
  const containerOpacity = cond(eq(leaveState, 1), maskOpacity, 1);
  const maskStyle = {
    opacity: maskOpacity,
    backgroundColor: '#000000'
  };
  const containerStyle = {
    opacity: containerOpacity,
    transform: [{
      translateY: translate
    }, {
      scale
    }]
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.container
  }, /*#__PURE__*/_react.default.createElement(_reactNative.TouchableWithoutFeedback, {
    onPress: onRequestClose
  }, /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: [_reactNative.StyleSheet.absoluteFill, maskStyle]
  })), /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.View, {
    style: containerStyle
  }, /*#__PURE__*/_react.default.createElement(InnerComponent, null)));
};

var _default = Modal;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: { ..._reactNative.StyleSheet.absoluteFillObject,
    alignItems: 'center',
    justifyContent: 'center'
  }
});
//# sourceMappingURL=Modal.js.map