"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNative = require("react-native");

var _responsibleTouchArea = _interopRequireDefault(require("./responsibleTouchArea"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiButton extends _react.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);
  }

  render() {
    const {
      wrapperStyle,
      innerStyle,
      ...otherProps
    } = this.props,
          ruuiStyles = (0, _utils.valueAt)(this, 'context.ruuiConfigs.button.styles', styles);
    return /*#__PURE__*/_react.default.createElement(_responsibleTouchArea.default, _extends({
      wrapperStyle: [ruuiStyles.wrapper, wrapperStyle],
      innerStyle: [ruuiStyles.contentContainer, innerStyle]
    }, otherProps), this.renderContent());
  }

  renderContent() {
    const {
      title,
      textStyle,
      icon,
      rightIcon,
      children
    } = this.props,
          ruuiStyles = (0, _utils.valueAt)(this, 'context.ruuiConfigs.button.styles', styles),
          textStyles = [ruuiStyles.titleText, textStyle];

    if (children) {
      return children;
    } else {
      return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: ruuiStyles.innerContainer
      }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: ruuiStyles.leftContainer
      }, icon), /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
        style: textStyles
      }, title), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
        style: ruuiStyles.rightContainer
      }, rightIcon));
    }
  }

}

_defineProperty(RuuiButton, "contextTypes", {
  ruuiConfigs: _propTypes.default.object
});

_defineProperty(RuuiButton, "defaultProps", {
  ripple: true,
  staticRipple: false,
  title: 'TITLE',
  disabled: false,
  raise: true,
  fade: true,
  fadeLevel: 0.2
});

var _default = RuuiButton;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  wrapper: {
    backgroundColor: _utils.colors.iOsBlue,
    borderRadius: 3
  },
  contentContainer: {
    padding: 10,
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center'
  },
  innerContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center'
  },
  leftContainer: {
    marginRight: 6
  },
  rightContainer: {
    marginLeft: 6
  },
  titleText: {
    color: '#FFFFFF',
    backgroundColor: 'transparent'
  }
});

exports.styles = styles;
//# sourceMappingURL=button.js.map