"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultContainerPropsGenerator = defaultContainerPropsGenerator;
exports.styles = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNative = require("react-native");

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiCloseableModal extends _react.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "onClose", () => {
      const {
        configs,
        onRequestClose
      } = this.props;
      onRequestClose(configs);
    });
  }

  render() {
    const {
      configs = {},
      animation,
      active
    } = this.props,
          globalConfigs = (0, _utils.valueAt)(this, 'context.ruuiConfigs.modal'),
          containerPropsGenerator = configs.containerProps || globalConfigs.containerProps,
          containerProps = containerPropsGenerator(animation, configs, active),
          InnerComponent = configs.component || configs.Component;

    if (configs.containerProps && !containerProps.style) {
      containerProps.style = globalConfigs.containerProps(animation, configs, active).style;
    }

    return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, containerProps, configs.tapToClose ? /*#__PURE__*/_react.default.createElement(_reactNative.TouchableWithoutFeedback, {
      onPress: this.onClose
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.touchableMask
    })) : /*#__PURE__*/_react.default.createElement(_reactNative.View, null), InnerComponent ? /*#__PURE__*/_react.default.createElement(InnerComponent, {
      animation: animation,
      configs: configs,
      close: this.onClose
    }) : /*#__PURE__*/_react.default.createElement(_reactNative.View, null));
  }

}

_defineProperty(RuuiCloseableModal, "props", void 0);

_defineProperty(RuuiCloseableModal, "contextTypes", {
  ruuiConfigs: _propTypes.default.object
});

var _default = RuuiCloseableModal;
exports.default = _default;

function defaultContainerPropsGenerator(animation, configs, isOpening) {
  const containerOpacity = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [0, 1]
  }),
        scale = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [isOpening ? 1.4 : 0.9, 1]
  }),
        translateY = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [150, 0]
  }),
        fullScreenStyles = configs.fullScreen ? {} : {
    alignItems: 'center',
    justifyContent: 'center'
  },
        containerStyles = {
    opacity: containerOpacity,
    transform: configs.fullScreen ? [{
      translateY
    }] : [{
      scale
    }]
  };
  return {
    style: [styles.container, fullScreenStyles, containerStyles]
  };
}

const styles = _reactNative.StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    right: 0,
    left: 0,
    bottom: 0
  },
  touchableMask: {
    position: 'absolute',
    top: 0,
    right: 0,
    left: 0,
    bottom: 0
  }
});

exports.styles = styles;
//# sourceMappingURL=closeableModal.js.map