"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _button = _interopRequireDefault(require("./button"));

var _utils = require("../utils");

var appActions = _interopRequireWildcard(require("../utils/store/appAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiConnectionMask extends _react.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "retry", () => {
      _reactNative.NetInfo.isConnected.fetch().then(isConnected => {
        this.props.dispatch(appActions.updateNetInfo({
          isConnected
        }));
      });
    });

    _defineProperty(this, "playAnimation", (toValue, callback) => {
      if (this.animation) this.animation.clear();
      const easing = toValue === 0 ? _reactNative.Easing.out(_reactNative.Easing.bezier(0, 0, 0.58, 1)) : _reactNative.Easing.in(_reactNative.Easing.bezier(0, 0.48, 0.35, 1)),
            animations = [_reactNative.Animated.timing(this.state.enterAnimation, {
        toValue,
        duration: 500,
        easing,
        useNativeDriver: true
      })];
      this.animation = _reactNative.Animated.parallel(animations).start(callback);
    });

    this.state = {
      enterAnimation: new _reactNative.Animated.Value(0)
    };
  }

  componentDidUpdate(prevProps) {
    const {
      netInfo
    } = this.props;

    if (prevProps.netInfo.isConnected !== netInfo.isConnected) {
      this.playAnimation(netInfo.isConnected ? 0 : 1);
    }
  }

  render() {
    const pointerEvents = this.props.netInfo.isConnected ? 'none' : 'auto',
          opacity = this.state.enterAnimation.interpolate({
      inputRange: [0, 1],
      outputRange: [0, 1]
    }),
          containerStyle = {
      opacity
    };
    return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
      pointerEvents: pointerEvents,
      style: [styles.container, this.props.wrapperStyle, containerStyle]
    }, this.props.contentRenderer ? this.props.contentRenderer(this.props.netInfo) : /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.innerContainer
    }, this.props.message, /*#__PURE__*/_react.default.createElement(_reactNative.ActivityIndicator, {
      color: "#ffffff",
      style: styles.activityIndicator
    }), /*#__PURE__*/_react.default.createElement(_button.default, {
      title: this.props.retryButtonCaption,
      icon: this.props.retryButtonIcon,
      rightIcon: this.props.retryButtonRightIcon,
      wrapperStyle: this.props.retryButtonWrapperStyle,
      innerStyle: this.props.retryButtonInnerStyle,
      onPress: this.retry
    })));
  }

}

_defineProperty(RuuiConnectionMask, "defaultProps", {
  message: /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
    style: {
      color: '#ffffff',
      fontSize: 20,
      textAlign: 'center'
    }
  }, "App need internet connection, waiting for reconnect.."),
  retryButtonCaption: 'Retry'
});

var _default = (0, _utils.connect)(({
  netInfo
}) => {
  return {
    netInfo
  };
})(RuuiConnectionMask);

exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    backgroundColor: 'rgba(0, 0, 0, 0.7)'
  },
  innerContainer: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0,
    justifyContent: 'center',
    alignItems: 'center',
    paddingHorizontal: 28
  },
  activityIndicator: {
    marginVertical: 20
  }
});
//# sourceMappingURL=connectionMask.js.map