"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNative = require("react-native");

var appActions = _interopRequireWildcard(require("../utils/store/appAction"));

var _typeDefinition = require("../typeDefinition");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiDropdownContainer extends _react.Component {
  constructor(props, context) {
    super(props);

    _defineProperty(this, "onPress", e => {
      const {
        onPress,
        dropdownEvent
      } = this.props;
      if (onPress) onPress(e);
      /* <- call default onPress, so that it'll work as normal */

      if (dropdownEvent === 'onPress') this.toggleDropdown();
    });

    _defineProperty(this, "onLongPress", e => {
      const {
        onLongPress,
        dropdownEvent
      } = this.props;
      if (onLongPress) onLongPress(e);
      /* <- call default onLongPress, so that it'll work as normal */

      if (dropdownEvent === 'onLongPress') this.toggleDropdown();
    });

    _defineProperty(this, "toggleDropdown", () => {
      const {
        id,
        dropdownWrapperStyle,
        dropdownComponent,
        dropdownDirection,
        animatedDirection,
        dropdownSpacing,
        dropdownOffset,
        dropdownContext,
        showArrow,
        arrowSize,
        arrowOffset,
        containerLayout,
        onClose
      } = this.props;
      this.container.measureLayout((0, _reactNative.findNodeHandle)(global.modalsContainer), (a, b, width, height) => {
        this.store.dispatch(appActions.toggleDropdown(true, {
          id: id || "Dropdown_".concat(Math.random()),
          wrapperStyle: dropdownWrapperStyle,
          component: dropdownComponent,
          containerLayout: containerLayout || {
            x: a,
            y: b,
            width,
            height
          },
          direction: dropdownDirection,
          animatedDirection: animatedDirection || dropdownDirection,
          spacing: dropdownSpacing,
          offset: dropdownOffset,
          showArrow,
          arrowSize,
          arrowOffset,
          context: dropdownContext,
          onClose
        }));
      });
    });

    this.store = context.ruuiStore;
  }

  render() {
    const {
      wrapperStyle,
      style,
      children,
      ...otherProps
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, _extends({
      style: wrapperStyle,
      onPress: this.onPress,
      onLongPress: this.onLongPress
    }, otherProps), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      renderToHardwareTextureAndroid: true,
      style: style,
      ref: container => {
        this.container = container;
      }
    }, children));
  }

}

_defineProperty(RuuiDropdownContainer, "props", void 0);

_defineProperty(RuuiDropdownContainer, "contextTypes", {
  ruuiStore: _propTypes.default.object
});

_defineProperty(RuuiDropdownContainer, "DropdownEvents", {
  onPress: 'onPress',
  onLongPress: 'onLongPress'
});

_defineProperty(RuuiDropdownContainer, "defaultProps", {
  dropdownEvent: 'onPress',
  dropdownDirection: 'bottom',
  dropdownSpacing: 10,
  dropdownOffset: {
    top: 0,
    left: 0
  }
});

var _default = RuuiDropdownContainer;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {}
});
//# sourceMappingURL=dropdownContainer.js.map