"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _utils = require("../utils");

var _typeDefinition = require("../typeDefinition");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const easeInSpeed = 450;

class RuuiInput extends _react.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onFloatingLabelLayout", ({
      nativeEvent: {
        layout
      }
    }) => {
      const {
        floatingLabelWidth
      } = this.state;

      if (!floatingLabelWidth) {
        this.setState({
          floatingLabelWidth: layout.width,
          floatingLabelHeight: layout.height
        });
      }
    });

    _defineProperty(this, "onInputFocus", () => {
      const {
        editable,
        onFocus
      } = this.props;

      if (editable) {
        this.setState({
          focus: true
        });
        this.playUnderlineAnimation(1);
        this.playFloatingLabelAnimation(1);
        if (onFocus) onFocus();
      }
    });

    _defineProperty(this, "onInputBlur", () => {
      const {
        forceFloating,
        value,
        onBlur
      } = this.props,
            noForceFloating = !forceFloating,
            hasEmptyValue = !value || !value.length;
      this.setState({
        focus: false
      });
      this.playUnderlineAnimation(0);
      if (noForceFloating && hasEmptyValue) this.playFloatingLabelAnimation(0);
      if (onBlur) onBlur();
    });

    _defineProperty(this, "playFloatingLabelAnimation", toValue => {
      if (this.floatingLabelAnimated) this.floatingLabelAnimated.clear();
      this.floatingLabelAnimated = _reactNative.Animated.timing(this.floatingAnimation, {
        toValue,
        duration: easeInSpeed,
        easing: _reactNative.Easing.in(_reactNative.Easing.bezier(0.23, 1, 0.32, 1)),
        useNativeDriver: true
      }).start();
    });

    _defineProperty(this, "playUnderlineAnimation", toValue => {
      if (this.underlineAnimated) this.underlineAnimated.clear();
      this.underlineAnimated = _reactNative.Animated.timing(this.underlineAnimation, {
        toValue,
        duration: easeInSpeed,
        easing: _reactNative.Easing.in(_reactNative.Easing.bezier(0.23, 1, 0.32, 1)),
        useNativeDriver: true
      }).start();
    });

    _defineProperty(this, "buildInputContainerStyles", (defaults = {}) => {
      const {
        floatingLabel
      } = this.props;
      return { ...defaults,
        paddingTop: (defaults.paddingTop || 0) + (floatingLabel ? 24 : 0)
      };
    });

    _defineProperty(this, "focus", () => {
      return this.textInput.focus && this.textInput.focus();
    });

    _defineProperty(this, "blur", () => {
      return this.textInput.blur && this.textInput.blur();
    });

    _defineProperty(this, "clear", () => {
      return this.textInput.clear && this.textInput.clear();
    });

    _defineProperty(this, "isFocused", () => {
      return this.textInput.isFocused && this.textInput.isFocused();
    });

    const shouldFloating = props.value && props.value.length > 0,
          initialFloating = props.forceFloating || shouldFloating ? 1 : 0;
    this.underlineAnimation = new _reactNative.Animated.Value(0);
    this.floatingAnimation = new _reactNative.Animated.Value(initialFloating);
    this.state = {
      floatingLabelWidth: 0,
      floatingLabelHeight: 0,
      focus: false
    };
  }

  componentDidUpdate(prevProps) {
    const {
      focus
    } = this.state,
          {
      floatingLabel,
      value
    } = this.props;

    if (floatingLabel) {
      if (value && value.length > 0) {
        if (!focus && (!prevProps.value || !prevProps.value.length)) {
          this.playFloatingLabelAnimation(1);
        }
      } else if (!focus && (!value || !value.length)) {
        this.playFloatingLabelAnimation(0);
      }
    }
  }

  render() {
    const {
      style,
      wrapperStyle,
      underlineStyle,
      floatingLabelStyle,
      underline,
      hint,
      hintColor,
      floatingLabel,
      forceFloating,
      errorText,
      disabled,
      prefix,
      suffix,
      ...textInputProps
    } = this.props,
          {
      focus,
      empty
    } = this.state,
          pointerEvents = disabled ? 'none' : 'auto',
          scale = this.underlineAnimation.interpolate({
      inputRange: [0, 1],
      outputRange: [0.0001, 1]
    }),
          containerStyles = underline ? {
      borderBottomWidth: 1,
      borderColor: '#f5f5f5'
    } : {},
          flattenUnderlineStyle = _reactNative.StyleSheet.flatten(underlineStyle) || {},
          underlineStyles = { ...flattenUnderlineStyle,
      transform: [{
        scaleX: scale
      }]
    },
          inputContainerStyles = this.buildInputContainerStyles(wrapperStyle),
          activeHint = focus && empty ? hint : '',
          platformProps = _utils.isAndroid ? {
      underlineColorAndroid: 'transparent'
    } : {};
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      pointerEvents: pointerEvents,
      style: [styles.container, containerStyles, inputContainerStyles]
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: {
        flexDirection: 'row'
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.addonContainer
    }, prefix), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.inputContainer
    }, /*#__PURE__*/_react.default.createElement(_reactNative.TextInput, _extends({
      ref: instance => {
        this.textInput = instance;
      }
    }, textInputProps, {
      onFocus: this.onInputFocus,
      onBlur: this.onInputBlur,
      style: [styles.textInput, style],
      placeholder: activeHint,
      placeholderTextColor: hintColor
    }, platformProps))), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.addonContainer
    }, suffix), this.renderFloatingLabel()), underline && /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
      style: [styles.inputUnderline, underlineStyles]
    }));
  }

  renderFloatingLabel() {
    const {
      floatingLabel,
      floatingLabelStyle
    } = this.props,
          {
      floatingLabelWidth,
      floatingLabelHeight
    } = this.state;

    if (floatingLabel) {
      const scaleSize = 0.8,
            scaledWidth = floatingLabelWidth * (1.05 - scaleSize),
            sideScaledWidth = scaledWidth / 2,
            scale = this.floatingAnimation.interpolate({
        inputRange: [0, 1],
        outputRange: [1, scaleSize]
      }),
            translateY = this.floatingAnimation.interpolate({
        inputRange: [0, 1],
        outputRange: [0, -floatingLabelHeight]
      }),
            translateX = this.floatingAnimation.interpolate({
        inputRange: [0, 1],
        outputRange: [0, -sideScaledWidth]
      }),
            wrapperStyles = {
        transform: [{
          scale
        }, {
          translateX
        }, {
          translateY
        }]
      },
            textStyles = {
        color: '#888888'
      };
      return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
        pointerEvents: "none",
        onLayout: this.onFloatingLabelLayout,
        style: [styles.floatingLabelWrapper, wrapperStyles]
      }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
        style: [styles.floatingLabelText, textStyles, floatingLabelStyle]
      }, floatingLabel));
    } else {
      return /*#__PURE__*/_react.default.createElement(_reactNative.View, null);
    }
  }

}

_defineProperty(RuuiInput, "defaultProps", {
  underline: true,
  editable: true
});

var _default = RuuiInput;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    backgroundColor: 'transparent'
  },
  addonContainer: {
    justifyContent: 'center',
    alignItems: 'center',
    paddingTop: 6
  },
  inputContainer: {
    flex: 1,
    marginLeft: 8,
    marginRight: 8
  },
  textInput: {
    height: 30,
    fontSize: 16,
    paddingTop: 6,
    paddingBottom: 0,
    color: '#444444'
  },
  inputUnderline: {
    height: 2,
    backgroundColor: '#F0871A',
    bottom: -1
  },
  floatingLabelWrapper: {
    position: 'absolute',
    justifyContent: 'center',
    height: 30,
    marginLeft: 8
  },
  floatingLabelText: {
    backgroundColor: 'transparent',
    fontSize: 16
  }
});
//# sourceMappingURL=input.js.map