"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _modal = _interopRequireDefault(require("./modal"));

var _dropdown = _interopRequireDefault(require("./dropdown"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiModals extends _react.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);
  }

  componentDidMount() {
    const {
      dispatch,
      preRenders,
      preRenderDelay
    } = this.props;

    if (preRenders !== null && preRenders !== void 0 && preRenders.length) {
      for (let i = 0; i < preRenders.length; i += 1) {
        const item = preRenders[i];
        item.flag = false;
        setTimeout(() => dispatch(item), i * preRenderDelay);
      }
    }
  }

  render() {
    const {
      dispatch,
      modals,
      screenSize,
      animationDelay
    } = this.props,
          modalArray = Object.keys(modals).map(key => Object.assign({}, modals[key], {
      id: key
    }));
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      ref: ref => {
        global.modalsContainer = ref;
      },
      pointerEvents: "box-none",
      style: styles.container
    }, modalArray.map((modalConfigs, i) => {
      if (modalConfigs.type === 'dropdown') {
        return /*#__PURE__*/_react.default.createElement(_dropdown.default, _extends({
          key: i,
          screenSize: screenSize
        }, modalConfigs));
      }

      return /*#__PURE__*/_react.default.createElement(_modal.default, _extends({
        key: i,
        modalCount: modalArray.filter(e => e.type !== 'dropdown').length,
        dispatch: dispatch,
        animationDelay: animationDelay
      }, modalConfigs));
    }));
  }

}

_defineProperty(RuuiModals, "defaultProps", {
  animationDelay: 200,
  preRenderDelay: 300
});

var _default = (0, _utils.connect)(({
  activeModals
}) => {
  return {
    modals: activeModals
  };
})(RuuiModals);

exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0
  }
});
//# sourceMappingURL=modals.js.map