"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNative = require("react-native");

var _utils = require("../utils");

var _typeDefinition = require("../typeDefinition");

var appAction = _interopRequireWildcard(require("../utils/store/appAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const defaultIcon = {
  uri: _utils.base64Icons.downArrow
};

const defaultTitleGet = item => item && item.title;

class RuuiSelect extends _react.Component {
  constructor(props, context) {
    super(props);

    _defineProperty(this, "activateSelector", () => {
      const {
        floatingLabel,
        value,
        ...otherProps
      } = this.props;
      this.store.dispatch(appAction.toggleSelector(true, {
        selectText: floatingLabel,
        activeOption: value,
        value,
        ...otherProps
      }));
    });

    this.store = context.ruuiStore;
  }

  render() {
    const {
      iconSource = defaultIcon,
      floatingLabel,
      iconStyle
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
      onPress: this.activateSelector,
      style: styles.container,
      activeOpacity: 0.8
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.contentWrapper
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.floatingLabel
    }, floatingLabel), this.renderValue()), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.iconWrapper
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
      style: [styles.downIcon, iconStyle],
      resizeMode: "contain",
      source: iconSource
    })));
  }

  renderValue() {
    const {
      value,
      getTitle
    } = this.props,
          valueText = getTitle(value) || 'Missing value option';
    return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.valueText
    }, valueText);
  }

}

exports.default = RuuiSelect;

_defineProperty(RuuiSelect, "props", void 0);

_defineProperty(RuuiSelect, "contextTypes", {
  ruuiStore: _propTypes.default.object
});

_defineProperty(RuuiSelect, "defaultProps", {
  floatingLabel: 'Select',
  cancelText: 'Cancel',
  options: [{
    title: 'Missing options param'
  }],
  tapToClose: true,
  getTitle: defaultTitleGet
});

const styles = _reactNative.StyleSheet.create({
  container: {
    flexDirection: 'row',
    borderBottomWidth: 1,
    borderColor: '#f5f5f5'
  },
  contentWrapper: {
    flex: 1
  },
  floatingLabel: {
    color: '#888888',
    fontSize: 12,
    paddingLeft: 8,
    paddingRight: 8,
    paddingTop: 5
  },
  valueText: {
    padding: 8,
    paddingTop: 8,
    paddingBottom: 5,
    color: '#444444',
    fontSize: 16
  },
  iconWrapper: {
    width: 50,
    justifyContent: 'center',
    alignItems: 'center'
  },
  downIcon: {
    width: 16,
    height: 16
  }
});
//# sourceMappingURL=select.js.map