"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _responsibleTouchArea = _interopRequireDefault(require("./responsibleTouchArea"));

var _radioIcon = _interopRequireDefault(require("./radioIcon"));

var _utils = require("../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class SelectorItem extends _react.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onItemPick", () => {
      const {
        onPress,
        optionInstance
      } = this.props;
      if (onPress) onPress(optionInstance);
    });
  }

  render() {
    const {
      optionInstance,
      activeInstance
    } = this.props,
          wrapperStyles = {},
          iconStyles = {};
    let isActive = false;

    if (JSON.stringify(activeInstance) === JSON.stringify(optionInstance)) {
      wrapperStyles.backgroundColor = '#fcfcfc';
      iconStyles.color = _utils.colors.iOsBlue;
      isActive = true;
    }

    return /*#__PURE__*/_react.default.createElement(_responsibleTouchArea.default, {
      rippleColor: _utils.colors.iOsBlue,
      onPress: this.onItemPick,
      wrapperStyle: [styles.optionItemWrapper, wrapperStyles],
      innerStyle: styles.optionItemInner,
      fadeLevel: 0.04
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.optionInnerWrapper
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.optionIconWrapper
    }, /*#__PURE__*/_react.default.createElement(_radioIcon.default, {
      active: isActive
    })), /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      style: styles.optionTextWrapper
    }, this.renderOptionText())));
  }

  renderOptionText() {
    const {
      optionInstance,
      getTitle
    } = this.props,
          optionTitle = getTitle(optionInstance);
    return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
      style: styles.optionTitle
    }, optionTitle);
  }

}

exports.default = SelectorItem;
const borderWidth = _utils.isAndroid ? 0 : 1,
      selectorPadding = _utils.isAndroid ? 20 : 8,
      selectionAlign = _utils.isAndroid ? 'left' : 'center';

const styles = _reactNative.StyleSheet.create({
  optionItemWrapper: {
    backgroundColor: '#f9f9f9',
    borderBottomWidth: borderWidth,
    borderColor: '#dedede'
  },
  optionInnerWrapper: {
    flexDirection: 'row'
  },
  optionIconWrapper: {
    width: 20,
    marginRight: 10,
    justifyContent: 'center',
    alignItems: 'center'
  },
  optionIcon: {
    color: '#dedede',
    fontSize: 18
  },
  optionItemInner: {
    padding: selectorPadding,
    paddingTop: 12,
    paddingBottom: 12
  },
  optionTextWrapper: {
    flex: 1,
    marginRight: 25
  },
  optionTitle: {
    color: _utils.colors.iOsBlue,
    fontSize: 17,
    textAlign: selectionAlign,
    backgroundColor: 'transparent'
  }
});
//# sourceMappingURL=selectorItem.js.map