"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _snackbar = _interopRequireDefault(require("./snackbar"));

var _ruuiStore = require("../utils/ruuiStore");

var appActions = _interopRequireWildcard(require("../utils/store/appAction"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const snackbarRadius = 3;

class Snackbars extends _react.Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onStartBarTimeout", configs => {
      this.props.dispatch(appActions.startDestroySnackBar(configs));
    });

    _defineProperty(this, "onBarTimeout", configs => {
      this.props.dispatch(appActions.destroySnackBar(configs));
    });
  }

  render() {
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      pointerEvents: "box-none",
      style: styles.container
    }, this.renderBars());
  }

  renderBars() {
    let aliveIndex = -1;
    const bars = [];

    for (let i = 0; i < this.props.snackBars.length; i += 1) {
      const barConfigs = this.props.snackBars[i];
      if (!barConfigs.destroying) aliveIndex += 1;
      bars.push( /*#__PURE__*/_react.default.createElement(_snackbar.default, {
        edge: this.props.edge,
        edgeOffset: this.props.edgeOffset,
        itemHeight: this.props.itemHeight,
        configs: barConfigs,
        key: barConfigs.id,
        index: i,
        aliveIndex: aliveIndex,
        onStartTimeout: this.onStartBarTimeout,
        onTimeout: this.onBarTimeout
      }));
    }

    return bars;
  }

}

_defineProperty(Snackbars, "edge", {
  top: 'top',
  bottom: 'bottom'
});

_defineProperty(Snackbars, "defaultProps", {
  edge: 'bottom',
  edgeOffset: 0,
  itemHeight: 56,
  animationSpeed: 1000,
  minWidth: 300,
  margin: 15
});

var _default = (0, _ruuiStore.connect)(({
  snackBars
}) => {
  return {
    snackBars
  };
})(Snackbars);

exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0
  },
  message: {
    color: '#ffffff'
  }
});
//# sourceMappingURL=snackbars.js.map