"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _lodash = require("lodash");

var _utils = require("../utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class RuuiTooltip extends _react.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "renderContent", () => {
      const {
        content
      } = this.props.tooltip.configs;

      if ((0, _lodash.isString)(content)) {
        return /*#__PURE__*/_react.default.createElement(_reactNative.Text, {
          style: styles.title
        }, content);
      } else {
        return content;
      }
    });

    this.enterAnimation = new _reactNative.Animated.Value(0);
    this.state = {
      top: 0,
      left: 0
    };
  }

  componentDidUpdate(previousProps, previousState, snapshot) {
    if (previousProps.tooltip.active !== this.props.tooltip.active) {
      this.container.measure((x, y, width, height) => {
        const {
          targetLayout,
          direction,
          positionSpacing
        } = this.props.tooltip.configs;
        this.setState((0, _utils.directionSnap)(targetLayout.y, targetLayout.x, targetLayout.width, targetLayout.height, width, height, direction, positionSpacing));

        _reactNative.Animated.timing(this.enterAnimation, {
          toValue: this.props.tooltip.active ? 1 : 0,
          duration: 500,
          easing: _reactNative.Easing.in(_reactNative.Easing.bezier(0.23, 1, 0.32, 1)),
          useNativeDriver: false
        }).start();
      });
    }
  }

  render() {
    const {
      tooltip
    } = this.props;
    const {
      top,
      left
    } = this.state;
    const animatedConfigs = (0, _utils.directionAnimatedConfigs)(tooltip.configs.direction, 10, this.enterAnimation);
    const innerStyles = animatedConfigs.borderRadius;
    const wrapperStyle = {
      top,
      left,
      transform: animatedConfigs.transform,
      opacity: animatedConfigs.opacity
    };
    return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
      pointerEvents: "none",
      style: [styles.wrapper, wrapperStyle]
    }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
      ref: instance => {
        this.container = instance;
      }
    }, /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
      style: [styles.container, innerStyles, tooltip.configs.innerStyle]
    }, this.renderContent())));
  }

}

var _default = (0, _utils.connect)(({
  dimensions,
  tooltip
}) => {
  return {
    screenSize: dimensions.window,
    tooltip
  };
})(RuuiTooltip);

exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  wrapper: {
    position: _utils.isWeb ? 'fixed' : 'absolute'
  },
  container: {
    padding: 5,
    paddingHorizontal: 8,
    backgroundColor: 'rgb(97, 97, 97)',
    borderRadius: 3
  },
  title: {
    fontSize: 11,
    fontWeight: '300',
    color: '#f5f5f5'
  }
});

exports.styles = styles;
//# sourceMappingURL=tooltip.js.map