"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactNative = require("react-native");

var appActions = _interopRequireWildcard(require("../store/action/app"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class TooltipContainer extends _react.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onMouseEnter", () => {
      const {
        ruuiStore
      } = this.context;
      const {
        tooltip,
        tooltipWrapperStyle,
        tooltipInnerStyle,
        tooltipDirection,
        tooltipPositionSpacing,
        tooltipPositionOffset
      } = this.props;

      if (tooltip) {
        this.wrapperView.measure((x, y, width, height, pageX, pageY) => {
          ruuiStore.dispatch(appActions.toggleTooltip(true, {
            targetLayout: {
              x: pageX,
              y: pageY,
              width,
              height
            },
            direction: tooltipDirection,
            positionSpacing: tooltipPositionSpacing,
            positionOffset: tooltipPositionOffset,
            content: tooltip,
            wrapperStyle: tooltipWrapperStyle,
            innerStyle: tooltipInnerStyle
          }));
        });
      }
    });

    _defineProperty(this, "onMouseLeave", () => {
      const {
        ruuiStore
      } = this.context;
      const {
        tooltip
      } = this.props;

      if (tooltip) {
        ruuiStore.dispatch(appActions.toggleTooltip(false));
      }
    });

    this.state = {
      mouseInside: false
    };
  }

  render() {
    const {
      tooltip,
      tooltipWrapperStyle,
      tooltipInnerStyle,
      tooltipDirection,
      tooltipPositionSpacing,
      tooltipPositionOffset,
      children,
      ...otherProps
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_reactNative.View, _extends({
      ref: instance => {
        this.wrapperView = instance;
      },
      onMouseEnter: this.onMouseEnter,
      onMouseLeave: this.onMouseLeave,
      collapsable: false
    }, otherProps), children);
  }

}

_defineProperty(TooltipContainer, "contextTypes", {
  ruuiStore: _propTypes.default.object
});

var _default = TooltipContainer;
exports.default = _default;
//# sourceMappingURL=tooltipContainer.js.map