"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _ripple = _interopRequireDefault(require("./ripple"));

var _utils = require("./utils");

var _context = require("../../utils/context");

var _typeDefinition = require("../../typeDefinition");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function RippleView(props) {
  const {
    style,
    children,
    staticRipple,
    fade,
    raise,
    disabled,
    ...otherProps
  } = props;
  const containerRef = (0, _react.useRef)();
  const ruuiStore = (0, _react.useContext)(_context.RuuiContext);
  const flattenStyle = _reactNative.StyleSheet.flatten(style) || {};
  const wrapperStyle = (0, _utils.extractWrapperStyle)(flattenStyle);
  const [onPressIn, onAnimationComplete, ripples] = (0, _utils.useRipple)(5, staticRipple, flattenStyle);

  const platformStyle = _reactNative.Platform.select({
    web: {
      cursor: 'pointer',
      userSelect: 'none'
    }
  });

  const platformProps = _reactNative.Platform.select({
    web: {
      onMouseEnter: () => {},
      onMouseLeave: () => {}
    },
    default: {}
  });

  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    ref: containerRef,
    style: [wrapperStyle, platformStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [_reactNative.StyleSheet.absoluteFill, {
      overflow: 'hidden'
    }]
  }, ripples.map(ripple => /*#__PURE__*/_react.default.createElement(_ripple.default, {
    key: ripple.id,
    id: ripple.id,
    style: ripple.style,
    onAnimationComplete: onAnimationComplete
  }))), /*#__PURE__*/_react.default.createElement(_reactNative.TouchableOpacity, {
    activeOpacity: 1,
    style: [style, {
      backgroundColor: 'transparent'
    }],
    disabled: disabled,
    onPressIn: e => onPressIn(containerRef, e)
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    pointerEvents: "none"
  }, children)));
}

RippleView.defaultProps = {
  fade: false,
  raise: false,
  disabled: false,
  staticRipple: false
};
var _default = RippleView;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {}
});
//# sourceMappingURL=index.js.map