"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _utils = require("../../utils");

var _typeDefinition = require("../../typeDefinition");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const {
  Value,
  timing
} = _reactNative.Animated;

function Ripple(props) {
  const {
    id,
    style,
    speed,
    initialOpacity,
    initialScale,
    onAnimationComplete
  } = props;
  const {
    current: expand
  } = (0, _react.useRef)(new Value(0));
  (0, _react.useEffect)(() => {
    timing(expand, {
      toValue: 1,
      duration: speed,
      easing: _reactNative.Easing.out(_reactNative.Easing.bezier(0.445, 0.05, 0.55, 0.95)),
      useNativeDriver: true
    }).start();
  }, []);
  const opacity = expand.interpolate({
    inputRange: [0, 0.5, 1],
    outputRange: [initialOpacity, 0.1, 0]
  });
  const scale = expand.interpolate({
    inputRange: [0, 0.1, 0.5, 1],
    outputRange: [initialScale, 0.4, 0.8, 1]
  });
  const containerStyle = {
    position: 'absolute',
    transform: [{
      scale
    }],
    opacity
  };
  return /*#__PURE__*/_react.default.createElement(_reactNative.Animated.View, {
    style: [style, containerStyle]
  });
}

Ripple.defaultProps = {
  speed: 800,
  initialOpacity: 0.2,
  initialScale: 0.02
};
var _default = Ripple;
exports.default = _default;

const styles = _reactNative.StyleSheet.create({
  container: {}
});
//# sourceMappingURL=ripple.js.map