"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _react = _interopRequireDefault(require("react"));

var _reactNative = require("react-native");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _default({
  speed = 500,
  delay = 0,
  fromValue = 0,
  toValue = 1,
  easing = _reactNative.Easing.out(_reactNative.Easing.cubic)
} = {}) {
  return function (BaseComponent) {
    return class EnterAnimationEnhancer extends BaseComponent {
      constructor(props) {
        super(props);
        this.enterAnimation = new _reactNative.Animated.Value(toValue);
      }

      componentDidMount() {
        this.enterAnimation.setValue(fromValue);
        setTimeout(() => {
          _reactNative.Animated.timing(this.enterAnimation, {
            toValue,
            easing,
            duration: speed,
            useNativeDriver: false
          }).start(() => {
            this.setState({
              animationFinished: true
            });
            super.animationDidFinish && super.animationDidFinish();
          });
        }, delay);
        super.componentDidMount && super.componentDidMount();
      }

    };
  };
}
//# sourceMappingURL=EnterAnimation.js.map