"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  createRuuiStore: true,
  utils: true,
  actions: true,
  appAction: true,
  ruuiActions: true,
  routeActions: true,
  routeAction: true,
  defaultConfigs: true,
  connect: true,
  RuuiContext: true,
  ruuiMiddleware: true,
  ruuiReducer: true
};
exports.createRuuiStore = createRuuiStore;
Object.defineProperty(exports, "connect", {
  enumerable: true,
  get: function () {
    return _ruuiStore.connect;
  }
});
Object.defineProperty(exports, "RuuiContext", {
  enumerable: true,
  get: function () {
    return _context.RuuiContext;
  }
});
Object.defineProperty(exports, "ruuiMiddleware", {
  enumerable: true,
  get: function () {
    return _store.ruuiMiddleware;
  }
});
Object.defineProperty(exports, "ruuiReducer", {
  enumerable: true,
  get: function () {
    return _store.ruuiReducer;
  }
});
exports.defaultConfigs = exports.routeAction = exports.routeActions = exports.ruuiActions = exports.appAction = exports.actions = exports.utils = void 0;

var utilsImport = _interopRequireWildcard(require("./utils"));

var actionsImport = _interopRequireWildcard(require("./utils/store/actions"));

var appActionImport = _interopRequireWildcard(require("./utils/store/appAction"));

var routeActionImport = _interopRequireWildcard(require("./utils/store/routeAction"));

var _core = _interopRequireDefault(require("./configs/core"));

var _appReducer = _interopRequireDefault(require("./store/appReducer"));

var _ruuiStore = require("./utils/ruuiStore");

var _context = require("./utils/context");

var _store = require("./store");

var _components = require("./components");

Object.keys(_components).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _components[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _components[key];
    }
  });
});

var _decorators = require("./decorators");

Object.keys(_decorators).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _decorators[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _decorators[key];
    }
  });
});

var _appReducer2 = require("./utils/store/appReducer");

Object.keys(_appReducer2).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _appReducer2[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _appReducer2[key];
    }
  });
});

var _routeReducer = require("./utils/store/routeReducer");

Object.keys(_routeReducer).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _routeReducer[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _routeReducer[key];
    }
  });
});

var _collection = require("./utils/collection");

Object.keys(_collection).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _collection[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _collection[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function createRuuiStore() {
  return (0, _ruuiStore.createStore)(_appReducer.default);
}

const utils = utilsImport;
exports.utils = utils;
const actions = actionsImport;
exports.actions = actions;
const appAction = appActionImport;
exports.appAction = appAction;
const ruuiActions = appActionImport;
exports.ruuiActions = ruuiActions;
const routeActions = routeActionImport;
exports.routeActions = routeActions;
const routeAction = routeActionImport;
exports.routeAction = routeAction;
const defaultConfigs = _core.default;
exports.defaultConfigs = defaultConfigs;
//# sourceMappingURL=index.js.map