"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ruuiMiddleware = exports.ruuiReducer = void 0;

var _ruuiStore = require("../utils/ruuiStore");

var _appReducer = _interopRequireWildcard(require("./appReducer"));

var appActions = _interopRequireWildcard(require("./action/app"));

var actions = _interopRequireWildcard(require("./actions"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ruuiReducer = (state = _appReducer.initialState, action) => {
  switch (action.type) {
    case actions.ReduxSync:
      return action.state;

    default:
      return state;
  }
};

exports.ruuiReducer = ruuiReducer;

const ruuiMiddleware = ruuiStore => {
  return reduxStore => {
    let reduxState = reduxStore.getState();
    if (reduxState.toJS) reduxState = reduxState.toJS();
    /* <- support Immutable state */

    if (reduxState.ruui) {
      ruuiStore.subscribe(() => {
        reduxStore.dispatch(appActions.reduxSync(ruuiStore.getState()));
      });
    }

    return next => action => {
      if (action.type !== actions.ReduxSync) {
        ruuiStore.dispatch(action);
      }

      next(action);
    };
  };
};

exports.ruuiMiddleware = ruuiMiddleware;
//# sourceMappingURL=index.js.map