"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  tinyColor: true,
  os: true,
  isWeb: true,
  isServer: true,
  isBrowser: true,
  isIos: true,
  isAndroid: true,
  connect: true
};
Object.defineProperty(exports, "connect", {
  enumerable: true,
  get: function () {
    return _ruuiStore.connect;
  }
});
exports.isAndroid = exports.isIos = exports.isBrowser = exports.isServer = exports.isWeb = exports.os = exports.tinyColor = void 0;

var _reactNative = require("react-native");

var _tinycolor = _interopRequireDefault(require("tinycolor2"));

var _ruuiStore = require("./ruuiStore");

var _colors = require("./colors");

Object.keys(_colors).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _colors[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _colors[key];
    }
  });
});

var _helpers = require("./helpers");

Object.keys(_helpers).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _helpers[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _helpers[key];
    }
  });
});

var _screen = require("./screen");

Object.keys(_screen).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _screen[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _screen[key];
    }
  });
});

var _icons = require("./icons");

Object.keys(_icons).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _icons[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _icons[key];
    }
  });
});

var _collection = require("./collection");

Object.keys(_collection).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _collection[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _collection[key];
    }
  });
});

var _animated = require("./animated");

Object.keys(_animated).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _animated[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _animated[key];
    }
  });
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const tinyColor = _tinycolor.default;
exports.tinyColor = tinyColor;
const os = _reactNative.Platform.OS;
exports.os = os;
const isWeb = os === 'web';
exports.isWeb = isWeb;
const isServer = isWeb && typeof window === 'undefined';
exports.isServer = isServer;
const isBrowser = isWeb && !isServer;
exports.isBrowser = isBrowser;
const isIos = os === 'ios';
exports.isIos = isIos;
const isAndroid = os === 'android';
exports.isAndroid = isAndroid;
//# sourceMappingURL=index.js.map