"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.screenWidthPadding = screenWidthPadding;
exports.horizontalPaddings = horizontalPaddings;
exports.horizontalSnappings = horizontalSnappings;
exports.isTouchDevice = isTouchDevice;
exports.ScreenSize = void 0;

var _reactNative = require("react-native");

const ScreenSize = _reactNative.Dimensions.get('window');

exports.ScreenSize = ScreenSize;

function screenWidthPadding(padding, maxSize) {
  const paddedSize = ScreenSize.width - padding * 2;
  return paddedSize > maxSize ? maxSize : paddedSize;
}

function horizontalPaddings(padding, maxSize) {
  const paddedSize = ScreenSize.width - padding * 2;
  return paddedSize > maxSize ? {
    width: maxSize
  } : {
    width: paddedSize,
    marginLeft: padding,
    marginRight: padding
  };
}

function horizontalSnappings(padding, minSize) {
  const paddedSize = ScreenSize.width - padding * 2;
  return paddedSize > minSize ? {
    width: minSize,
    marginLeft: padding,
    marginRight: padding
  } : {
    width: ScreenSize.width
  };
}

function isTouchDevice() {
  if (['android', 'ios'].indexOf(_reactNative.Platform.OS) >= 0) {
    return true;
  } else {
    try {
      document.createEvent('TouchEvent');
      return true;
    } catch (e) {
      return false;
    }
  }
}
//# sourceMappingURL=screen.js.map