"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetState = resetState;
exports.updateThemeConfigs = updateThemeConfigs;
exports.updateDimensionsInfo = updateDimensionsInfo;
exports.updateNetInfo = updateNetInfo;
exports.toggleSelector = toggleSelector;
exports.toggleModal = toggleModal;
exports.toggleDropdown = toggleDropdown;
exports.toggleLoading = toggleLoading;
exports.insertSnackBar = insertSnackBar;
exports.startDestroySnackBar = startDestroySnackBar;
exports.destroySnackBar = destroySnackBar;

var Actions = _interopRequireWildcard(require("./actions"));

var _helpers = require("../helpers");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function resetState() {
  return {
    type: Actions.ResetState
  };
}

function updateThemeConfigs(configs = {}) {
  return {
    type: Actions.UpdateThemeConfigs,
    configs
  };
}

function updateDimensionsInfo(info = {}) {
  return {
    type: Actions.UpdateDimensionInfo,
    info
  };
}

function updateNetInfo(info = {}) {
  return {
    type: Actions.UpdateNetInfo,
    info
  };
}

function toggleSelector(flag, configs = {}) {
  return {
    type: Actions.ToggleSelect,
    flag,
    configs
  };
}

function toggleModal(flag, configs = {}) {
  return {
    type: Actions.ToggleModal,
    flag,
    configs
  };
}

function toggleDropdown(flag, configs = {}) {
  return {
    type: Actions.ToggleDropdown,
    flag,
    configs
  };
}

function toggleLoading(flag, configs = {}) {
  return {
    type: Actions.ToggleLoading,
    flag,
    configs
  };
}

function insertSnackBar(configs = {}) {
  return {
    type: Actions.InsertSnackBar,
    configs: { ...configs,
      id: configs.id || (0, _helpers.uuid)()
    }
  };
}

function startDestroySnackBar(configs = {}) {
  return {
    type: Actions.StartDestroySnackBar,
    configs
  };
}

function destroySnackBar(configs = {}) {
  return {
    type: Actions.DestroySnackBar,
    configs
  };
}
//# sourceMappingURL=appAction.js.map