var addCommand, chalk, childProcess, commander, commands, configs, defaultOptParser, handleError, init, path, pkg, printUnknownCommand, run, ssrUtils;
path = require("path");
childProcess = require("child_process");
({
  chalk,
  commander
} = require("./util/modules"));
commands = require("./commands/index");
init = require("./commands/init");
pkg = require("../../../../package.json");
configs = require("./util/configs");
ssrUtils = require("./util/ssr");
commander.version(pkg.version);

defaultOptParser = function (val) {
  return val;
};

handleError = function (err) {
  console.error();
  console.error(err.message || err);
  console.error();
  return process.exit(1);
};

printUnknownCommand = function (cmdName) {
  var firstLine, spacing;
  spacing = "  ";
  firstLine = cmdName ? "Unrecognized command `".concat(cmdName, "`") : " You didn't pass any command";
  firstLine = chalk.red(firstLine);
  return console.log("\n".concat(spacing).concat(firstLine, "\n").concat(spacing, "Run ").concat(chalk.cyan("ruui --help"), " to see list of all available commands\n"));
};

addCommand = function (command, cfg) {
  var cmd, options;
  options = command.options || [];
  cmd = commander.command(command.name, void 0, {
    noHelp: !command.description
  }).description(command.description).action(function () {
    var argv, passedOptions;
    passedOptions = this.opts();
    argv = Array.from(arguments).slice(0, -1);
    return Promise.resolve().then(function () {
      return command.func(argv, cfg, passedOptions);
    }).catch(handleError);
  });
  options.forEach(function (opt) {
    return cmd.option(opt.command, opt.description, opt.parse || defaultOptParser, typeof opt.default === "function" ? opt.default(cfg) : opt.default);
  });
  return cmd.option("--config [string]", "Path to the CLI configuration file");
};

run = function () {
  var isValidCommand;
  commands.forEach(function (cmd) {
    return addCommand(cmd, {});
  });
  commander.parse(process.argv);
  isValidCommand = commands.find(function (cmd) {
    return cmd.name.split(" ")[0] === process.argv[2];
  });

  if (!isValidCommand) {
    printUnknownCommand(process.argv[2]);
    return;
  }

  if (!commander.args.length) {
    return commander.help();
  }
};

module.exports = {
  configs,
  ssrUtils,
  init,
  run: function () {
    var isValidCommand;
    commands.forEach(function (cmd) {
      return addCommand(cmd, {});
    });
    commander.parse(process.argv);
    isValidCommand = commands.find(function (cmd) {
      return cmd.name.split(' ')[0] === process.argv[2];
    });

    if (!isValidCommand) {
      printUnknownCommand(process.argv[2]);
      return;
    }

    if (!commander.args.length) {
      return commander.help();
    }
  }
};
//# sourceMappingURL=cliEntry.js.map