var chalk, childProcess, electronModule, electronNotFound, fs, isPortTaken, launchElectron, path, run, ruui;
fs = require("fs");
path = require("path");
childProcess = require("child_process");
({
  chalk
} = require("../util/modules"));
({
  ruui
} = require("../util/configs"));
({
  electronModule,
  isPortTaken
} = require("../util/helper"));

run = async function (argv, config, args) {
  var devServer, electronPath, host, port, runningHost, serverPortTaken;
  electronPath = electronModule("index.js");

  if (!fs.existsSync(electronPath)) {
    console.log(electronNotFound), process.exit(1);
  }

  host = ruui.host();
  port = ruui.port();
  runningHost = host === "0.0.0.0" ? "localhost" : host;
  serverPortTaken = await isPortTaken({
    port: ruui.port(),
    host: ruui.host()
  });
  console.log("launching electron..");

  if (!serverPortTaken) {
    console.log("preparing development server at ".concat(runningHost, ":").concat(chalk.gray(port)));
    devServer = require("../tools/webpack.devserver")();
    devServer.listen(port, host || "0.0.0.0", function (error, result) {
      if (error) {
        console.log(error);
      }

      return true;
    });
    return setTimeout(function () {
      return launchElectron(electronPath);
    }, 0);
  } else {
    console.log("development server already running at ".concat(runningHost, ":").concat(chalk.gray(port)));
    return launchElectron(electronPath);
  }
};

launchElectron = function (electronPath) {
  var child, electron;
  electron = require(electronPath);
  child = childProcess.spawn(electron, ["-r", "@babel/register", "./electron"], {
    cwd: process.cwd(),
    stdio: "inherit"
  });
  return child.on("close", function (code) {
    return process.exit(code);
  });
};

electronNotFound = "Cannot locate ".concat(chalk.magenta("electron"), " package,\nrun `").concat(chalk.green("ruui extends --addon electron"), "` to install it..");
module.exports = {
  name: "electron",
  description: 'launch your app using Electron',
  func: run
};
//# sourceMappingURL=electron.js.map