var appJson, fs, path, paths, ruuiCliModule, ruuiConfig, ruuiJson, ruuiModule;
fs = require("fs");
path = require("path");
({
  ruuiModule,
  ruuiCliModule
} = require("./helper"));
paths = {
  ruui: path.resolve(process.cwd(), "ruui"),
  ruuiConfig: path.resolve(process.cwd(), "ruui.config.js"),
  packageJson: path.resolve(process.cwd(), "package.json"),
  appJson: path.resolve(process.cwd(), "app.json"),
  ruuiJson: path.resolve(process.cwd(), "ruui", "ruui.json"),
  getEnv: function (name) {
    return ruuiModule("cli", "env", "".concat(name, ".env"));
  },
  getEjsTemplate: function () {
    var defaultEjsPath, localEjsPath, manualEjsPath;
    manualEjsPath = path.resolve(process.cwd(), "index.ejs");
    localEjsPath = path.resolve(process.cwd(), "cli", "index.ejs");
    defaultEjsPath = ruuiModule("cli", "index.ejs");

    if (fs.existsSync(manualEjsPath)) {
      return manualEjsPath;
    } else if (fs.existsSync(localEjsPath)) {
      return localEjsPath;
    } else {
      return defaultEjsPath;
    }
  }
};
appJson = {};
ruuiJson = {};
ruuiConfig = {};

if (fs.existsSync(paths.appJson)) {
  appJson = require(paths.appJson);
}

if (fs.existsSync(paths.ruuiJson)) {
  ruuiJson = require(paths.ruuiJson);
}

ruuiConfig = {
  publicPath: function (env) {
    return '/';
  },
  host: function () {
    return process.env.HOST || "localhost";
  },
  port: function () {
    return process.env.PORT || 3000;
  },
  env: function () {
    return process.env.ENV || "development";
  },
  optimizeMode: function () {
    return process.env.OPTIMIZE === "true";
  }
};

if (fs.existsSync(paths.ruuiConfig)) {
  ruuiConfig = Object.assign(ruuiConfig, require(paths.ruuiConfig));
}

module.exports = {
  paths,
  appJson,
  ruuiJson,
  ruui: ruuiConfig
};
//# sourceMappingURL=configs.js.map