function _templateObject() {
  const data = _taggedTemplateLiteral(["", " ", ""]);

  _templateObject = function () {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SEPARATOR, chalk, debug, error, formatMessages, info, log, setVerbose, success, verbose, warn;
({
  chalk
} = require("./modules"));
SEPARATOR = ', ';
verbose = false;

formatMessages = function (messages) {
  return chalk.reset(messages.join(SEPARATOR));
};

success = function (...messages) {
  return console.log("".concat(chalk.green.bold('success'), " ").concat(formatMessages(messages)));
};

info = function (...messages) {
  return console.log(_templateObject(), chalk.cyan.bold('info'), formatMessages(messages));
};

warn = function (...messages) {
  return console.warn("".concat(chalk.yellow.bold('warn'), " ").concat(formatMessages(messages)));
};

error = function (...messages) {
  return console.error("".concat(chalk.red.bold('error'), " ").concat(formatMessages(messages)));
};

debug = function (...messages) {
  if (verbose) {
    return console.log("".concat(chalk.gray.bold('debug'), " ").concat(formatMessages(messages)));
  }
};

log = function (...messages) {
  return console.log("".concat(formatMessages(messages)));
};

setVerbose = function (level) {
  return verbose = level;
};

module.exports = {
  success,
  info,
  warn,
  error,
  debug,
  log,
  setVerbose
};
//# sourceMappingURL=logger.js.map