import React from 'react';
import { StyleSheet, View, Text } from 'react-native';
import Modal from './Modal';
import { connect } from '../../utils';

const RuuiFloats = props => {
  const {
    dispatch,
    floatMap
  } = props;
  const floats = Object.keys(floatMap).map(key => ({ ...floatMap[key],
    id: key
  })).filter(item => item.active);
  return /*#__PURE__*/React.createElement(View, {
    pointerEvents: "box-none",
    style: StyleSheet.absoluteFill
  }, floats.map(item => {
    return /*#__PURE__*/React.createElement(Modal, {
      key: item.id,
      item: item,
      dispatch: dispatch
    });
  }));
};

export default connect(({
  activeModals
}) => {
  return {
    floatMap: activeModals
  };
})(RuuiFloats);
const styles = StyleSheet.create({
  container: {}
});
//# sourceMappingURL=index.js.map