function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { View, Text, StyleSheet } from 'react-native';
import ResponsibleTouchArea from './responsibleTouchArea';
import { colors, valueAt } from '../utils';

class RuuiButton extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);
  }

  render() {
    const {
      wrapperStyle,
      innerStyle,
      ...otherProps
    } = this.props,
          ruuiStyles = valueAt(this, 'context.ruuiConfigs.button.styles', styles);
    return /*#__PURE__*/React.createElement(ResponsibleTouchArea, _extends({
      wrapperStyle: [ruuiStyles.wrapper, wrapperStyle],
      innerStyle: [ruuiStyles.contentContainer, innerStyle]
    }, otherProps), this.renderContent());
  }

  renderContent() {
    const {
      title,
      textStyle,
      icon,
      rightIcon,
      children
    } = this.props,
          ruuiStyles = valueAt(this, 'context.ruuiConfigs.button.styles', styles),
          textStyles = [ruuiStyles.titleText, textStyle];

    if (children) {
      return children;
    } else {
      return /*#__PURE__*/React.createElement(View, {
        style: ruuiStyles.innerContainer
      }, /*#__PURE__*/React.createElement(View, {
        style: ruuiStyles.leftContainer
      }, icon), /*#__PURE__*/React.createElement(Text, {
        style: textStyles
      }, title), /*#__PURE__*/React.createElement(View, {
        style: ruuiStyles.rightContainer
      }, rightIcon));
    }
  }

}

_defineProperty(RuuiButton, "contextTypes", {
  ruuiConfigs: PropTypes.object
});

_defineProperty(RuuiButton, "defaultProps", {
  ripple: true,
  staticRipple: false,
  title: 'TITLE',
  disabled: false,
  raise: true,
  fade: true,
  fadeLevel: 0.2
});

export default RuuiButton;
export const styles = StyleSheet.create({
  wrapper: {
    backgroundColor: colors.iOsBlue,
    borderRadius: 3
  },
  contentContainer: {
    padding: 10,
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center'
  },
  innerContainer: {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'center'
  },
  leftContainer: {
    marginRight: 6
  },
  rightContainer: {
    marginLeft: 6
  },
  titleText: {
    color: '#FFFFFF',
    backgroundColor: 'transparent'
  }
});
//# sourceMappingURL=button.js.map