function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { Animated, TouchableWithoutFeedback, View, StyleSheet } from 'react-native';
import { valueAt } from '../utils';

class RuuiCloseableModal extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "onClose", () => {
      const {
        configs,
        onRequestClose
      } = this.props;
      onRequestClose(configs);
    });
  }

  render() {
    const {
      configs = {},
      animation,
      active
    } = this.props,
          globalConfigs = valueAt(this, 'context.ruuiConfigs.modal'),
          containerPropsGenerator = configs.containerProps || globalConfigs.containerProps,
          containerProps = containerPropsGenerator(animation, configs, active),
          InnerComponent = configs.component || configs.Component;

    if (configs.containerProps && !containerProps.style) {
      containerProps.style = globalConfigs.containerProps(animation, configs, active).style;
    }

    return /*#__PURE__*/React.createElement(Animated.View, containerProps, configs.tapToClose ? /*#__PURE__*/React.createElement(TouchableWithoutFeedback, {
      onPress: this.onClose
    }, /*#__PURE__*/React.createElement(View, {
      style: styles.touchableMask
    })) : /*#__PURE__*/React.createElement(View, null), InnerComponent ? /*#__PURE__*/React.createElement(InnerComponent, {
      animation: animation,
      configs: configs,
      close: this.onClose
    }) : /*#__PURE__*/React.createElement(View, null));
  }

}

_defineProperty(RuuiCloseableModal, "props", void 0);

_defineProperty(RuuiCloseableModal, "contextTypes", {
  ruuiConfigs: PropTypes.object
});

export default RuuiCloseableModal;
export function defaultContainerPropsGenerator(animation, configs, isOpening) {
  const containerOpacity = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [0, 1]
  }),
        scale = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [isOpening ? 1.4 : 0.9, 1]
  }),
        translateY = animation.interpolate({
    inputRange: [0, 1],
    outputRange: [150, 0]
  }),
        fullScreenStyles = configs.fullScreen ? {} : {
    alignItems: 'center',
    justifyContent: 'center'
  },
        containerStyles = {
    opacity: containerOpacity,
    transform: configs.fullScreen ? [{
      translateY
    }] : [{
      scale
    }]
  };
  return {
    style: [styles.container, fullScreenStyles, containerStyles]
  };
}
export const styles = StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    right: 0,
    left: 0,
    bottom: 0
  },
  touchableMask: {
    position: 'absolute',
    top: 0,
    right: 0,
    left: 0,
    bottom: 0
  }
});
//# sourceMappingURL=closeableModal.js.map