function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { View, TouchableOpacity, StyleSheet, findNodeHandle } from 'react-native';
import * as appActions from '../utils/store/appAction';
import { Style, Element, SnappingDirection, Layout } from '../typeDefinition';

class RuuiDropdownContainer extends Component {
  constructor(props, context) {
    super(props);

    _defineProperty(this, "onPress", e => {
      const {
        onPress,
        dropdownEvent
      } = this.props;
      if (onPress) onPress(e);
      /* <- call default onPress, so that it'll work as normal */

      if (dropdownEvent === 'onPress') this.toggleDropdown();
    });

    _defineProperty(this, "onLongPress", e => {
      const {
        onLongPress,
        dropdownEvent
      } = this.props;
      if (onLongPress) onLongPress(e);
      /* <- call default onLongPress, so that it'll work as normal */

      if (dropdownEvent === 'onLongPress') this.toggleDropdown();
    });

    _defineProperty(this, "toggleDropdown", () => {
      const {
        id,
        dropdownWrapperStyle,
        dropdownComponent,
        dropdownDirection,
        animatedDirection,
        dropdownSpacing,
        dropdownOffset,
        dropdownContext,
        showArrow,
        arrowSize,
        arrowOffset,
        containerLayout,
        onClose
      } = this.props;
      this.container.measureLayout(findNodeHandle(global.modalsContainer), (a, b, width, height) => {
        this.store.dispatch(appActions.toggleDropdown(true, {
          id: id || "Dropdown_".concat(Math.random()),
          wrapperStyle: dropdownWrapperStyle,
          component: dropdownComponent,
          containerLayout: containerLayout || {
            x: a,
            y: b,
            width,
            height
          },
          direction: dropdownDirection,
          animatedDirection: animatedDirection || dropdownDirection,
          spacing: dropdownSpacing,
          offset: dropdownOffset,
          showArrow,
          arrowSize,
          arrowOffset,
          context: dropdownContext,
          onClose
        }));
      });
    });

    this.store = context.ruuiStore;
  }

  render() {
    const {
      wrapperStyle,
      style,
      children,
      ...otherProps
    } = this.props;
    return /*#__PURE__*/React.createElement(TouchableOpacity, _extends({
      style: wrapperStyle,
      onPress: this.onPress,
      onLongPress: this.onLongPress
    }, otherProps), /*#__PURE__*/React.createElement(View, {
      renderToHardwareTextureAndroid: true,
      style: style,
      ref: container => {
        this.container = container;
      }
    }, children));
  }

}

_defineProperty(RuuiDropdownContainer, "props", void 0);

_defineProperty(RuuiDropdownContainer, "contextTypes", {
  ruuiStore: PropTypes.object
});

_defineProperty(RuuiDropdownContainer, "DropdownEvents", {
  onPress: 'onPress',
  onLongPress: 'onLongPress'
});

_defineProperty(RuuiDropdownContainer, "defaultProps", {
  dropdownEvent: 'onPress',
  dropdownDirection: 'bottom',
  dropdownSpacing: 10,
  dropdownOffset: {
    top: 0,
    left: 0
  }
});

export default RuuiDropdownContainer;
const styles = StyleSheet.create({
  container: {}
});
//# sourceMappingURL=dropdownContainer.js.map