function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { ActivityIndicator, View, TouchableOpacity, StyleSheet } from 'react-native';
import * as appActions from '../utils/store/appAction';

class RuuiLoadingModal extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onMaskPress", () => {
      const {
        dispatch,
        configs
      } = this.props;

      if (configs.tapToClose) {
        dispatch(appActions.toggleLoading(false));
      }
    });
  }

  render() {
    const {
      configs = {}
    } = this.props,
          indicatorColor = configs.indicatorColor || '#ffffff',
          indicatorSize = configs.indicatorSize || 'small';
    return /*#__PURE__*/React.createElement(View, {
      style: styles.container
    }, /*#__PURE__*/React.createElement(TouchableOpacity, {
      onPress: this.onMaskPress
    }, /*#__PURE__*/React.createElement(ActivityIndicator, {
      color: indicatorColor,
      size: indicatorSize
    })));
  }

}

export default RuuiLoadingModal;
const styles = StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    right: 0,
    left: 0,
    bottom: 0,
    alignItems: 'center',
    justifyContent: 'center'
  }
});
//# sourceMappingURL=loadingMask.js.map