function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { View, StyleSheet } from 'react-native';
import Modal from './modal';
import RuuiDropdown from './dropdown';
import { connect } from '../utils';

class RuuiModals extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);
  }

  componentDidMount() {
    const {
      dispatch,
      preRenders,
      preRenderDelay
    } = this.props;

    if (preRenders !== null && preRenders !== void 0 && preRenders.length) {
      for (let i = 0; i < preRenders.length; i += 1) {
        const item = preRenders[i];
        item.flag = false;
        setTimeout(() => dispatch(item), i * preRenderDelay);
      }
    }
  }

  render() {
    const {
      dispatch,
      modals,
      screenSize,
      animationDelay
    } = this.props,
          modalArray = Object.keys(modals).map(key => Object.assign({}, modals[key], {
      id: key
    }));
    return /*#__PURE__*/React.createElement(View, {
      ref: ref => {
        global.modalsContainer = ref;
      },
      pointerEvents: "box-none",
      style: styles.container
    }, modalArray.map((modalConfigs, i) => {
      if (modalConfigs.type === 'dropdown') {
        return /*#__PURE__*/React.createElement(RuuiDropdown, _extends({
          key: i,
          screenSize: screenSize
        }, modalConfigs));
      }

      return /*#__PURE__*/React.createElement(Modal, _extends({
        key: i,
        modalCount: modalArray.filter(e => e.type !== 'dropdown').length,
        dispatch: dispatch,
        animationDelay: animationDelay
      }, modalConfigs));
    }));
  }

}

_defineProperty(RuuiModals, "defaultProps", {
  animationDelay: 200,
  preRenderDelay: 300
});

export default connect(({
  activeModals
}) => {
  return {
    modals: activeModals
  };
})(RuuiModals);
const styles = StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0
  }
});
//# sourceMappingURL=modals.js.map