function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { Animated, Easing } from 'react-native';
import { Style } from '../typeDefinition';

class RuuiRippleEffect extends Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    this.expandAnimation = new Animated.Value(0);
  }

  componentDidMount() {
    Animated.timing(this.expandAnimation, {
      toValue: 1,
      duration: this.props.speed,
      easing: Easing.out(Easing.bezier(0.445, 0.05, 0.55, 0.95)),
      useNativeDriver: true
    }).start();
  }

  render() {
    const {
      style,
      initialScale,
      initialOpacity
    } = this.props,
          opacity = this.expandAnimation.interpolate({
      inputRange: [0, 0.5, 1],
      outputRange: [initialOpacity, 0.1, 0]
    }),
          scale = this.expandAnimation.interpolate({
      inputRange: [0, 0.1, 0.5, 1],
      outputRange: [initialScale, 0.4, 0.8, 1]
    }),
          styles = { ...style,
      position: 'absolute',
      transform: [{
        scale
      }],
      opacity
    };
    return /*#__PURE__*/React.createElement(Animated.View, {
      pointerEvents: "none",
      style: styles
    });
  }

}

_defineProperty(RuuiRippleEffect, "defaultProps", {
  initialOpacity: 0.2,
  initialScale: 0.02,
  speed: 800
});

export default RuuiRippleEffect;
//# sourceMappingURL=rippleEffect.js.map