function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { View, Text, StyleSheet } from 'react-native';
import ResponsibleTouchArea from './responsibleTouchArea';
import RadioIcon from './radioIcon';
import { colors, isAndroid } from '../utils';
export default class SelectorItem extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onItemPick", () => {
      const {
        onPress,
        optionInstance
      } = this.props;
      if (onPress) onPress(optionInstance);
    });
  }

  render() {
    const {
      optionInstance,
      activeInstance
    } = this.props,
          wrapperStyles = {},
          iconStyles = {};
    let isActive = false;

    if (JSON.stringify(activeInstance) === JSON.stringify(optionInstance)) {
      wrapperStyles.backgroundColor = '#fcfcfc';
      iconStyles.color = colors.iOsBlue;
      isActive = true;
    }

    return /*#__PURE__*/React.createElement(ResponsibleTouchArea, {
      rippleColor: colors.iOsBlue,
      onPress: this.onItemPick,
      wrapperStyle: [styles.optionItemWrapper, wrapperStyles],
      innerStyle: styles.optionItemInner,
      fadeLevel: 0.04
    }, /*#__PURE__*/React.createElement(View, {
      style: styles.optionInnerWrapper
    }, /*#__PURE__*/React.createElement(View, {
      style: styles.optionIconWrapper
    }, /*#__PURE__*/React.createElement(RadioIcon, {
      active: isActive
    })), /*#__PURE__*/React.createElement(View, {
      style: styles.optionTextWrapper
    }, this.renderOptionText())));
  }

  renderOptionText() {
    const {
      optionInstance,
      getTitle
    } = this.props,
          optionTitle = getTitle(optionInstance);
    return /*#__PURE__*/React.createElement(Text, {
      style: styles.optionTitle
    }, optionTitle);
  }

}
const borderWidth = isAndroid ? 0 : 1,
      selectorPadding = isAndroid ? 20 : 8,
      selectionAlign = isAndroid ? 'left' : 'center';
const styles = StyleSheet.create({
  optionItemWrapper: {
    backgroundColor: '#f9f9f9',
    borderBottomWidth: borderWidth,
    borderColor: '#dedede'
  },
  optionInnerWrapper: {
    flexDirection: 'row'
  },
  optionIconWrapper: {
    width: 20,
    marginRight: 10,
    justifyContent: 'center',
    alignItems: 'center'
  },
  optionIcon: {
    color: '#dedede',
    fontSize: 18
  },
  optionItemInner: {
    padding: selectorPadding,
    paddingTop: 12,
    paddingBottom: 12
  },
  optionTextWrapper: {
    flex: 1,
    marginRight: 25
  },
  optionTitle: {
    color: colors.iOsBlue,
    fontSize: 17,
    textAlign: selectionAlign,
    backgroundColor: 'transparent'
  }
});
//# sourceMappingURL=selectorItem.js.map