function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import { Animated, Easing, View, Text, StyleSheet } from 'react-native';
import Snackbar from './snackbar';
import { connect } from '../utils/ruuiStore';
import * as appActions from '../utils/store/appAction';
const snackbarRadius = 3;

class Snackbars extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onStartBarTimeout", configs => {
      this.props.dispatch(appActions.startDestroySnackBar(configs));
    });

    _defineProperty(this, "onBarTimeout", configs => {
      this.props.dispatch(appActions.destroySnackBar(configs));
    });
  }

  render() {
    return /*#__PURE__*/React.createElement(View, {
      pointerEvents: "box-none",
      style: styles.container
    }, this.renderBars());
  }

  renderBars() {
    let aliveIndex = -1;
    const bars = [];

    for (let i = 0; i < this.props.snackBars.length; i += 1) {
      const barConfigs = this.props.snackBars[i];
      if (!barConfigs.destroying) aliveIndex += 1;
      bars.push( /*#__PURE__*/React.createElement(Snackbar, {
        edge: this.props.edge,
        edgeOffset: this.props.edgeOffset,
        itemHeight: this.props.itemHeight,
        configs: barConfigs,
        key: barConfigs.id,
        index: i,
        aliveIndex: aliveIndex,
        onStartTimeout: this.onStartBarTimeout,
        onTimeout: this.onBarTimeout
      }));
    }

    return bars;
  }

}

_defineProperty(Snackbars, "edge", {
  top: 'top',
  bottom: 'bottom'
});

_defineProperty(Snackbars, "defaultProps", {
  edge: 'bottom',
  edgeOffset: 0,
  itemHeight: 56,
  animationSpeed: 1000,
  minWidth: 300,
  margin: 15
});

export default connect(({
  snackBars
}) => {
  return {
    snackBars
  };
})(Snackbars);
const styles = StyleSheet.create({
  container: {
    position: 'absolute',
    top: 0,
    bottom: 0,
    left: 0,
    right: 0
  },
  message: {
    color: '#ffffff'
  }
});
//# sourceMappingURL=snackbars.js.map