function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { View } from 'react-native';
import * as appActions from '../store/action/app';

class TooltipContainer extends Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "props", void 0);

    _defineProperty(this, "onMouseEnter", () => {
      const {
        ruuiStore
      } = this.context;
      const {
        tooltip,
        tooltipWrapperStyle,
        tooltipInnerStyle,
        tooltipDirection,
        tooltipPositionSpacing,
        tooltipPositionOffset
      } = this.props;

      if (tooltip) {
        this.wrapperView.measure((x, y, width, height, pageX, pageY) => {
          ruuiStore.dispatch(appActions.toggleTooltip(true, {
            targetLayout: {
              x: pageX,
              y: pageY,
              width,
              height
            },
            direction: tooltipDirection,
            positionSpacing: tooltipPositionSpacing,
            positionOffset: tooltipPositionOffset,
            content: tooltip,
            wrapperStyle: tooltipWrapperStyle,
            innerStyle: tooltipInnerStyle
          }));
        });
      }
    });

    _defineProperty(this, "onMouseLeave", () => {
      const {
        ruuiStore
      } = this.context;
      const {
        tooltip
      } = this.props;

      if (tooltip) {
        ruuiStore.dispatch(appActions.toggleTooltip(false));
      }
    });

    this.state = {
      mouseInside: false
    };
  }

  render() {
    const {
      tooltip,
      tooltipWrapperStyle,
      tooltipInnerStyle,
      tooltipDirection,
      tooltipPositionSpacing,
      tooltipPositionOffset,
      children,
      ...otherProps
    } = this.props;
    return /*#__PURE__*/React.createElement(View, _extends({
      ref: instance => {
        this.wrapperView = instance;
      },
      onMouseEnter: this.onMouseEnter,
      onMouseLeave: this.onMouseLeave,
      collapsable: false
    }, otherProps), children);
  }

}

_defineProperty(TooltipContainer, "contextTypes", {
  ruuiStore: PropTypes.object
});

export default TooltipContainer;
//# sourceMappingURL=tooltipContainer.js.map